/*
 * BYOND String Utilities
 * ObjectReference.cpp
 *
 *  Created on: 15 Jan 2011
 *      Author: Stephen Badger (Stephen001)
 */

#include "ObjectReference.h"
#include <sstream>

Reference::Reference(std::string name, unsigned long id) : __name(name), __id(id) {}

Reference::~Reference() {}

const std::string & Reference::name() const {
	return __name;
}

unsigned long Reference::id() const {
	return __id;
}

std::istream & operator>>(std::istream & stream, Reference & ref) {
	stream >> ref.__id;
	stream >> ref.__name;
	return stream;
}

std::ostream & operator<<(std::ostream & stream, const Reference & ref) {
	stream << ref. __id << ref.__name;
	return stream;
}

std::map<std::string, std::vector<DataObject *> * > DataObject::data;

Reference DataObject::add_new_object(std::string & name, DataObject * object) {
	if (DataObject::data.find(name) == DataObject::data.end()) {
		DataObject::data[name] = new std::vector<DataObject *>();
	}
	std::vector<DataObject *> * objects = DataObject::data.find(name)->second;
	objects->insert(objects->end(), object);
	return Reference(name, objects->size() - 1);
}

DataObject * DataObject::get_from_reference(const Reference & ref) {
	std::vector<DataObject *> * objects = DataObject::data.find(ref.name())->second;
	return (*objects)[ref.id()];
}

void DataObject::destroy_from_reference(const Reference & ref) {
	std::vector<DataObject *> * objects = DataObject::data.find(ref.name())->second;
	objects->erase(objects->begin() + ref.id());
	objects->insert(objects->begin() + ref.id(), new DataObject());
}
Reference get_reference(char * text) {
	Reference ref(std::string("FAILED"), 0);
	std::string arg0(text);
	std::istringstream istream(arg0);
	istream >> ref;
	return ref;
}


