/*
 * BYOND String Utilities
 * StringBuilder.cpp
 *
 *  Created on: 15 Jan 2011
 *      Author: Stephen Badger (Stephen001)
 */

#include "StringBuilder.h"
#include <sstream>

StringBuilder::~StringBuilder() {}

void StringBuilder::add(char * text) {
	data.push_back(std::string(text));
}

char * StringBuilder::result() {
	int size = 0;
	std::list<std::string>::iterator it = data.begin();
	while (it != data.end()) {
		size += (*it).size();
		it++;
	}
	it = data.begin();
	std::string result;
	result.reserve(size);
	while (it != data.end()) {
		result += (*it);
		it++;
	}
	return const_cast<char *>(result.c_str());
}

char * new_string_builder(int argc, char ** argv) {
	StringBuilder  * builder = new StringBuilder();
	std::ostringstream stream;
	std::string name("StringBuilder");
	Reference ref = DataObject::add_new_object(name, builder);
	stream << ref;
	std::string result = stream.str();
	return const_cast<char *>(result.c_str());
}

char * add_string_builder(int argc, char ** argv) {
	Reference ref = get_reference(argv[0]);
	StringBuilder * builder = static_cast<StringBuilder *>(DataObject::get_from_reference(ref));
	builder->add(argv[1]);
	return 0;
}

char * result_string_builder(int argc, char ** argv) {
	Reference ref = get_reference(argv[0]);
	StringBuilder * builder = static_cast<StringBuilder *>(DataObject::get_from_reference(ref));
	return builder->result();
}

char * delete_string_builder(int argc, char ** argv) {
	Reference ref = get_reference(argv[0]);
	DataObject::destroy_from_reference(ref);
	return 0;
}
